Index: /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 94708)
+++ /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 94709)
@@ -895,4 +895,5 @@
 	src/settings/UISettingsSerializer.h \
 	src/settings/editors/UIAudioControllerEditor.h \
+	src/settings/editors/UIAudioFeaturesEditor.h \
 	src/settings/editors/UIAudioHostDriverEditor.h \
 	src/settings/editors/UIAudioSettingsEditor.h \
@@ -910,5 +911,4 @@
 	src/settings/editors/UIHotKeyEditor.h \
 	src/settings/editors/UILanguageSettingsEditor.h \
-	src/settings/editors/UIMachineAudioFeaturesEditor.h \
 	src/settings/editors/UIMachineDisplayScreenFeaturesEditor.h \
 	src/settings/editors/UIMachineDescriptionEditor.h \
@@ -1464,4 +1464,5 @@
 	src/settings/UISettingsSerializer.cpp \
 	src/settings/editors/UIAudioControllerEditor.cpp \
+	src/settings/editors/UIAudioFeaturesEditor.cpp \
 	src/settings/editors/UIAudioHostDriverEditor.cpp \
 	src/settings/editors/UIAudioSettingsEditor.cpp \
@@ -1479,5 +1480,4 @@
 	src/settings/editors/UIHotKeyEditor.cpp \
 	src/settings/editors/UILanguageSettingsEditor.cpp \
-	src/settings/editors/UIMachineAudioFeaturesEditor.cpp \
 	src/settings/editors/UIMachineDisplayScreenFeaturesEditor.cpp \
 	src/settings/editors/UIMachineDescriptionEditor.cpp \
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioFeaturesEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioFeaturesEditor.cpp	(revision 94709)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioFeaturesEditor.cpp	(revision 94709)
@@ -0,0 +1,133 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIAudioFeaturesEditor class implementation.
+ */
+
+/*
+ * Copyright (C) 2006-2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+/* Qt includes: */
+#include <QCheckBox>
+#include <QGridLayout>
+#include <QLabel>
+
+/* GUI includes: */
+#include "UIAudioFeaturesEditor.h"
+
+
+UIAudioFeaturesEditor::UIAudioFeaturesEditor(QWidget *pParent /* = 0 */)
+    : QIWithRetranslateUI<QWidget>(pParent)
+    , m_fEnableOutput(false)
+    , m_fEnableInput(false)
+    , m_pLabel(0)
+    , m_pCheckBoxEnableOutput(0)
+    , m_pCheckBoxEnableInput(0)
+{
+    prepare();
+}
+
+void UIAudioFeaturesEditor::setEnableOutput(bool fOn)
+{
+    /* Update cached value and
+     * check-box if value has changed: */
+    if (m_fEnableOutput != fOn)
+    {
+        m_fEnableOutput = fOn;
+        if (m_pCheckBoxEnableOutput)
+            m_pCheckBoxEnableOutput->setCheckState(m_fEnableOutput ? Qt::Checked : Qt::Unchecked);
+    }
+}
+
+bool UIAudioFeaturesEditor::outputEnabled() const
+{
+    return   m_pCheckBoxEnableOutput
+           ? m_pCheckBoxEnableOutput->checkState() == Qt::Checked
+           : m_fEnableOutput;
+}
+
+void UIAudioFeaturesEditor::setEnableInput(bool fOn)
+{
+    /* Update cached value and
+     * check-box if value has changed: */
+    if (m_fEnableInput != fOn)
+    {
+        m_fEnableInput = fOn;
+        if (m_pCheckBoxEnableInput)
+            m_pCheckBoxEnableInput->setCheckState(m_fEnableInput ? Qt::Checked : Qt::Unchecked);
+    }
+}
+
+bool UIAudioFeaturesEditor::inputEnabled() const
+{
+    return   m_pCheckBoxEnableInput
+           ? m_pCheckBoxEnableInput->checkState() == Qt::Checked
+           : m_fEnableInput;
+}
+
+int UIAudioFeaturesEditor::minimumLabelHorizontalHint() const
+{
+    return m_pLabel ? m_pLabel->minimumSizeHint().width() : 0;
+}
+
+void UIAudioFeaturesEditor::setMinimumLayoutIndent(int iIndent)
+{
+    if (m_pLayout)
+        m_pLayout->setColumnMinimumWidth(0, iIndent);
+}
+
+void UIAudioFeaturesEditor::retranslateUi()
+{
+    if (m_pLabel)
+        m_pLabel->setText(tr("Extended Features:"));
+    if (m_pCheckBoxEnableOutput)
+    {
+        m_pCheckBoxEnableOutput->setText(tr("Enable Audio &Output"));
+        m_pCheckBoxEnableOutput->setToolTip(tr("When checked, output to the virtual audio device will reach the host. "
+                                               "Otherwise the guest is muted."));
+    }
+    if (m_pCheckBoxEnableInput)
+    {
+        m_pCheckBoxEnableInput->setText(tr("Enable Audio &Input"));
+        m_pCheckBoxEnableInput->setToolTip(tr("When checked, the guest will be able to capture audio input from the host. "
+                                              "Otherwise the guest will capture only silence."));
+    }
+}
+
+void UIAudioFeaturesEditor::prepare()
+{
+    /* Prepare main layout: */
+    m_pLayout = new QGridLayout(this);
+    if (m_pLayout)
+    {
+        m_pLayout->setContentsMargins(0, 0, 0, 0);
+        m_pLayout->setColumnStretch(1, 1);
+
+        /* Prepare label: */
+        m_pLabel = new QLabel(this);
+        if (m_pLabel)
+        {
+            m_pLabel->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
+            m_pLayout->addWidget(m_pLabel, 0, 0);
+        }
+        /* Prepare 'enable output' check-box: */
+        m_pCheckBoxEnableOutput = new QCheckBox(this);
+        if (m_pCheckBoxEnableOutput)
+            m_pLayout->addWidget(m_pCheckBoxEnableOutput, 0, 1);
+        /* Prepare 'enable input' check-box: */
+        m_pCheckBoxEnableInput = new QCheckBox(this);
+        if (m_pCheckBoxEnableInput)
+            m_pLayout->addWidget(m_pCheckBoxEnableInput, 1, 1);
+    }
+
+    /* Apply language settings: */
+    retranslateUi();
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioFeaturesEditor.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioFeaturesEditor.h	(revision 94709)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioFeaturesEditor.h	(revision 94709)
@@ -0,0 +1,88 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UIAudioFeaturesEditor class declaration.
+ */
+
+/*
+ * Copyright (C) 2006-2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef FEQT_INCLUDED_SRC_settings_editors_UIAudioFeaturesEditor_h
+#define FEQT_INCLUDED_SRC_settings_editors_UIAudioFeaturesEditor_h
+#ifndef RT_WITHOUT_PRAGMA_ONCE
+# pragma once
+#endif
+
+/* GUI includes: */
+#include "QIWithRetranslateUI.h"
+
+/* Forward declarations: */
+class QCheckBox;
+class QGridLayout;
+class QLabel;
+
+/** QWidget subclass used as audio features editor. */
+class SHARED_LIBRARY_STUFF UIAudioFeaturesEditor : public QIWithRetranslateUI<QWidget>
+{
+    Q_OBJECT;
+
+public:
+
+    /** Constructs editor passing @a pParent to the base-class. */
+    UIAudioFeaturesEditor(QWidget *pParent = 0);
+
+    /** Defines whether 'enable output' feature in @a fOn. */
+    void setEnableOutput(bool fOn);
+    /** Returns 'enable output' feature value. */
+    bool outputEnabled() const;
+
+    /** Defines whether 'enable input' feature in @a fOn. */
+    void setEnableInput(bool fOn);
+    /** Returns 'enable input' feature value. */
+    bool inputEnabled() const;
+
+    /** Returns minimum layout hint. */
+    int minimumLabelHorizontalHint() const;
+    /** Defines minimum layout @a iIndent. */
+    void setMinimumLayoutIndent(int iIndent);
+
+protected:
+
+    /** Handles translation event. */
+    virtual void retranslateUi() RT_OVERRIDE;
+
+private:
+
+    /** Prepares all. */
+    void prepare();
+
+    /** @name Values
+     * @{ */
+        /** Holds the 'enable output' feature value. */
+        bool  m_fEnableOutput;
+        /** Holds the 'enable input' feature value. */
+        bool  m_fEnableInput;
+    /** @} */
+
+    /** @name Widgets
+     * @{ */
+        /** Holds the main layout instance. */
+        QGridLayout *m_pLayout;
+        /** Holds the label instance. */
+        QLabel      *m_pLabel;
+        /** Holds the 'enable output' check-box instance. */
+        QCheckBox   *m_pCheckBoxEnableOutput;
+        /** Holds the 'enable input' check-box instance. */
+        QCheckBox   *m_pCheckBoxEnableInput;
+    /** @} */
+};
+
+#endif /* !FEQT_INCLUDED_SRC_settings_editors_UIAudioFeaturesEditor_h */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioSettingsEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioSettingsEditor.cpp	(revision 94708)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioSettingsEditor.cpp	(revision 94709)
@@ -23,7 +23,7 @@
 /* GUI includes: */
 #include "UIAudioControllerEditor.h"
+#include "UIAudioFeaturesEditor.h"
 #include "UIAudioHostDriverEditor.h"
 #include "UIAudioSettingsEditor.h"
-#include "UIMachineAudioFeaturesEditor.h"
 
 
@@ -200,11 +200,11 @@
                     pLayoutAudioSettings->addWidget(m_pEditorAudioHostDriver);
 
-                /* Prepare host controller editor: */
+                /* Prepare controller editor: */
                 m_pEditorAudioController = new UIAudioControllerEditor(m_pWidgetSettings);
                 if (m_pEditorAudioController)
                     pLayoutAudioSettings->addWidget(m_pEditorAudioController);
 
-                /* Prepare extended features editor: */
-                m_pEditorAudioFeatures = new UIMachineAudioFeaturesEditor(m_pWidgetSettings);
+                /* Prepare features editor: */
+                m_pEditorAudioFeatures = new UIAudioFeaturesEditor(m_pWidgetSettings);
                 if (m_pEditorAudioFeatures)
                     pLayoutAudioSettings->addWidget(m_pEditorAudioFeatures);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioSettingsEditor.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioSettingsEditor.h	(revision 94708)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIAudioSettingsEditor.h	(revision 94709)
@@ -36,6 +36,6 @@
 class QCheckBox;
 class UIAudioControllerEditor;
+class UIAudioFeaturesEditor;
 class UIAudioHostDriverEditor;
-class UIMachineAudioFeaturesEditor;
 
 /** QWidget subclass used as a audio settings editor. */
@@ -129,13 +129,13 @@
      * @{ */
         /** Holds the feature check-box instance. */
-        QCheckBox                    *m_pCheckboxFeature;
+        QCheckBox               *m_pCheckboxFeature;
         /** Holds the settings widget instance. */
-        QWidget                      *m_pWidgetSettings;
-        /** Holds the audio host driver editor instance. */
-        UIAudioHostDriverEditor      *m_pEditorAudioHostDriver;
-        /** Holds the audio host controller editor instance. */
-        UIAudioControllerEditor      *m_pEditorAudioController;
-        /** Holds the audio features editor instance. */
-        UIMachineAudioFeaturesEditor *m_pEditorAudioFeatures;
+        QWidget                 *m_pWidgetSettings;
+        /** Holds the host driver editor instance. */
+        UIAudioHostDriverEditor *m_pEditorAudioHostDriver;
+        /** Holds the controller editor instance. */
+        UIAudioControllerEditor *m_pEditorAudioController;
+        /** Holds the features editor instance. */
+        UIAudioFeaturesEditor   *m_pEditorAudioFeatures;
     /** @} */
 };
Index: unk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIMachineAudioFeaturesEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIMachineAudioFeaturesEditor.cpp	(revision 94708)
+++ 	(revision )
@@ -1,133 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIMachineAudioFeaturesEditor class implementation.
- */
-
-/*
- * Copyright (C) 2006-2022 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-/* Qt includes: */
-#include <QCheckBox>
-#include <QGridLayout>
-#include <QLabel>
-
-/* GUI includes: */
-#include "UIMachineAudioFeaturesEditor.h"
-
-
-UIMachineAudioFeaturesEditor::UIMachineAudioFeaturesEditor(QWidget *pParent /* = 0 */)
-    : QIWithRetranslateUI<QWidget>(pParent)
-    , m_fEnableOutput(false)
-    , m_fEnableInput(false)
-    , m_pLabel(0)
-    , m_pCheckBoxEnableOutput(0)
-    , m_pCheckBoxEnableInput(0)
-{
-    prepare();
-}
-
-void UIMachineAudioFeaturesEditor::setEnableOutput(bool fOn)
-{
-    /* Update cached value and
-     * check-box if value has changed: */
-    if (m_fEnableOutput != fOn)
-    {
-        m_fEnableOutput = fOn;
-        if (m_pCheckBoxEnableOutput)
-            m_pCheckBoxEnableOutput->setCheckState(m_fEnableOutput ? Qt::Checked : Qt::Unchecked);
-    }
-}
-
-bool UIMachineAudioFeaturesEditor::outputEnabled() const
-{
-    return   m_pCheckBoxEnableOutput
-           ? m_pCheckBoxEnableOutput->checkState() == Qt::Checked
-           : m_fEnableOutput;
-}
-
-void UIMachineAudioFeaturesEditor::setEnableInput(bool fOn)
-{
-    /* Update cached value and
-     * check-box if value has changed: */
-    if (m_fEnableInput != fOn)
-    {
-        m_fEnableInput = fOn;
-        if (m_pCheckBoxEnableInput)
-            m_pCheckBoxEnableInput->setCheckState(m_fEnableInput ? Qt::Checked : Qt::Unchecked);
-    }
-}
-
-bool UIMachineAudioFeaturesEditor::inputEnabled() const
-{
-    return   m_pCheckBoxEnableInput
-           ? m_pCheckBoxEnableInput->checkState() == Qt::Checked
-           : m_fEnableInput;
-}
-
-int UIMachineAudioFeaturesEditor::minimumLabelHorizontalHint() const
-{
-    return m_pLabel ? m_pLabel->minimumSizeHint().width() : 0;
-}
-
-void UIMachineAudioFeaturesEditor::setMinimumLayoutIndent(int iIndent)
-{
-    if (m_pLayout)
-        m_pLayout->setColumnMinimumWidth(0, iIndent);
-}
-
-void UIMachineAudioFeaturesEditor::retranslateUi()
-{
-    if (m_pLabel)
-        m_pLabel->setText(tr("Extended Features:"));
-    if (m_pCheckBoxEnableOutput)
-    {
-        m_pCheckBoxEnableOutput->setText(tr("Enable Audio &Output"));
-        m_pCheckBoxEnableOutput->setToolTip(tr("When checked, output to the virtual audio device will reach the host. "
-                                               "Otherwise the guest is muted."));
-    }
-    if (m_pCheckBoxEnableInput)
-    {
-        m_pCheckBoxEnableInput->setText(tr("Enable Audio &Input"));
-        m_pCheckBoxEnableInput->setToolTip(tr("When checked, the guest will be able to capture audio input from the host. "
-                                              "Otherwise the guest will capture only silence."));
-    }
-}
-
-void UIMachineAudioFeaturesEditor::prepare()
-{
-    /* Prepare main layout: */
-    m_pLayout = new QGridLayout(this);
-    if (m_pLayout)
-    {
-        m_pLayout->setContentsMargins(0, 0, 0, 0);
-        m_pLayout->setColumnStretch(1, 1);
-
-        /* Prepare label: */
-        m_pLabel = new QLabel(this);
-        if (m_pLabel)
-        {
-            m_pLabel->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-            m_pLayout->addWidget(m_pLabel, 0, 0);
-        }
-        /* Prepare 'enable output' check-box: */
-        m_pCheckBoxEnableOutput = new QCheckBox(this);
-        if (m_pCheckBoxEnableOutput)
-            m_pLayout->addWidget(m_pCheckBoxEnableOutput, 0, 1);
-        /* Prepare 'enable input' check-box: */
-        m_pCheckBoxEnableInput = new QCheckBox(this);
-        if (m_pCheckBoxEnableInput)
-            m_pLayout->addWidget(m_pCheckBoxEnableInput, 1, 1);
-    }
-
-    /* Apply language settings: */
-    retranslateUi();
-}
Index: unk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIMachineAudioFeaturesEditor.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIMachineAudioFeaturesEditor.h	(revision 94708)
+++ 	(revision )
@@ -1,88 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIMachineAudioFeaturesEditor class declaration.
- */
-
-/*
- * Copyright (C) 2006-2022 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef FEQT_INCLUDED_SRC_settings_editors_UIMachineAudioFeaturesEditor_h
-#define FEQT_INCLUDED_SRC_settings_editors_UIMachineAudioFeaturesEditor_h
-#ifndef RT_WITHOUT_PRAGMA_ONCE
-# pragma once
-#endif
-
-/* GUI includes: */
-#include "QIWithRetranslateUI.h"
-
-/* Forward declarations: */
-class QCheckBox;
-class QGridLayout;
-class QLabel;
-
-/** QWidget subclass used as machine audio features editor. */
-class SHARED_LIBRARY_STUFF UIMachineAudioFeaturesEditor : public QIWithRetranslateUI<QWidget>
-{
-    Q_OBJECT;
-
-public:
-
-    /** Constructs editor passing @a pParent to the base-class. */
-    UIMachineAudioFeaturesEditor(QWidget *pParent = 0);
-
-    /** Defines whether 'enable output' feature in @a fOn. */
-    void setEnableOutput(bool fOn);
-    /** Returns 'enable output' feature value. */
-    bool outputEnabled() const;
-
-    /** Defines whether 'enable input' feature in @a fOn. */
-    void setEnableInput(bool fOn);
-    /** Returns 'enable input' feature value. */
-    bool inputEnabled() const;
-
-    /** Returns minimum layout hint. */
-    int minimumLabelHorizontalHint() const;
-    /** Defines minimum layout @a iIndent. */
-    void setMinimumLayoutIndent(int iIndent);
-
-protected:
-
-    /** Handles translation event. */
-    virtual void retranslateUi() RT_OVERRIDE;
-
-private:
-
-    /** Prepares all. */
-    void prepare();
-
-    /** @name Values
-     * @{ */
-        /** Holds the 'enable output' feature value. */
-        bool  m_fEnableOutput;
-        /** Holds the 'enable input' feature value. */
-        bool  m_fEnableInput;
-    /** @} */
-
-    /** @name Widgets
-     * @{ */
-        /** Holds the main layout instance. */
-        QGridLayout *m_pLayout;
-        /** Holds the label instance. */
-        QLabel      *m_pLabel;
-        /** Holds the 'enable output' check-box instance. */
-        QCheckBox   *m_pCheckBoxEnableOutput;
-        /** Holds the 'enable input' check-box instance. */
-        QCheckBox   *m_pCheckBoxEnableInput;
-    /** @} */
-};
-
-#endif /* !FEQT_INCLUDED_SRC_settings_editors_UIMachineAudioFeaturesEditor_h */