Index: /trunk/src/VBox/Frontends/VirtualBox/src/networking/UIUpdateDefs.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/networking/UIUpdateDefs.cpp	(revision 94732)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/networking/UIUpdateDefs.cpp	(revision 94733)
@@ -27,5 +27,5 @@
 
 /* static: */
-VBoxUpdateDayList VBoxUpdateData::m_dayList = VBoxUpdateDayList();
+VBoxUpdateDayList VBoxUpdateData::s_days = VBoxUpdateDayList();
 
 /* static */
@@ -33,5 +33,5 @@
 {
     /* Clear list initially: */
-    m_dayList.clear();
+    s_days.clear();
 
     // WORKAROUND:
@@ -40,18 +40,18 @@
 
     /* Separately retranslate each day: */
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "1 day"),  "1 d");
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "2 days"), "2 d");
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "3 days"), "3 d");
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "4 days"), "4 d");
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "5 days"), "5 d");
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "6 days"), "6 d");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "1 day"),   "1 d");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "2 days"),  "2 d");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "3 days"),  "3 d");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "4 days"),  "4 d");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "5 days"),  "5 d");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "6 days"),  "6 d");
 
     /* Separately retranslate each week: */
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "1 week"),  "1 w");
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "2 weeks"), "2 w");
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "3 weeks"), "3 w");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "1 week"),  "1 w");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "2 weeks"), "2 w");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "3 weeks"), "3 w");
 
     /* Separately retranslate each month: */
-    m_dayList << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "1 month"), "1 m");
+    s_days << VBoxUpdateDay(QCoreApplication::translate("UIUpdateManager", "1 month"), "1 m");
 }
 
@@ -60,6 +60,6 @@
 {
     QStringList result;
-    for (int i = 0; i < m_dayList.size(); ++i)
-        result << m_dayList.at(i).val;
+    foreach (const VBoxUpdateDay &day, s_days)
+        result << day.val;
     return result;
 }
@@ -67,5 +67,5 @@
 VBoxUpdateData::VBoxUpdateData(const QString &strData)
     : m_strData(strData)
-    , m_enmPeriodIndex(Period1Day)
+    , m_enmUpdatePeriod(UpdatePeriodType_1Day)
     , m_enmUpdateChannel(KUpdateChannel_Stable)
 {
@@ -73,7 +73,7 @@
 }
 
-VBoxUpdateData::VBoxUpdateData(PeriodType enmPeriodIndex, KUpdateChannel enmUpdateChannel)
+VBoxUpdateData::VBoxUpdateData(UpdatePeriodType enmUpdatePeriod, KUpdateChannel enmUpdateChannel)
     : m_strData(QString())
-    , m_enmPeriodIndex(enmPeriodIndex)
+    , m_enmUpdatePeriod(enmUpdatePeriod)
     , m_enmUpdateChannel(enmUpdateChannel)
 {
@@ -84,5 +84,5 @@
 {
     /* No need to check if Period == Never: */
-    return m_enmPeriodIndex == PeriodNever;
+    return m_enmUpdatePeriod == UpdatePeriodType_Never;
 }
 
@@ -110,7 +110,7 @@
 }
 
-VBoxUpdateData::PeriodType VBoxUpdateData::periodIndex() const
-{
-    return m_enmPeriodIndex;
+UpdatePeriodType VBoxUpdateData::updatePeriod() const
+{
+    return m_enmUpdatePeriod;
 }
 
@@ -145,5 +145,5 @@
     return    true
            && (m_strData == another.data())
-           && (m_enmPeriodIndex == another.periodIndex())
+           && (m_enmUpdatePeriod == another.updatePeriod())
            && (m_date == another.internalDate())
            && (m_enmUpdateChannel == another.updateChannel())
@@ -188,5 +188,5 @@
     /* Parse standard values: */
     if (m_strData == "never")
-        m_enmPeriodIndex = PeriodNever;
+        m_enmUpdatePeriod = UpdatePeriodType_Never;
     /* Parse other values: */
     else
@@ -201,8 +201,8 @@
         if (parser.size() > 0)
         {
-            if (m_dayList.isEmpty())
+            if (s_days.isEmpty())
                 populate();
-            PeriodType index = (PeriodType)m_dayList.indexOf(VBoxUpdateDay(QString(), parser.at(0)));
-            m_enmPeriodIndex = index == PeriodUndefined ? Period1Day : index;
+            const UpdatePeriodType enmUpdatePeriod = (UpdatePeriodType)s_days.indexOf(VBoxUpdateDay(QString(), parser.at(0)));
+            m_enmUpdatePeriod = enmUpdatePeriod == UpdatePeriodType_Never ? UpdatePeriodType_1Day : enmUpdatePeriod;
         }
 
@@ -231,5 +231,5 @@
 {
     /* Encode standard values: */
-    if (m_enmPeriodIndex == PeriodNever)
+    if (m_enmUpdatePeriod == UpdatePeriodType_Never)
         m_strData = "never";
     /* Encode other values: */
@@ -237,7 +237,7 @@
     {
         /* Encode 'period' value: */
-        if (m_dayList.isEmpty())
+        if (s_days.isEmpty())
             populate();
-        QString remindPeriod = m_dayList[m_enmPeriodIndex].key;
+        QString remindPeriod = s_days.at(m_enmUpdatePeriod).key;
 
         /* Encode 'date' value: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/networking/UIUpdateDefs.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/networking/UIUpdateDefs.h	(revision 94732)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/networking/UIUpdateDefs.h	(revision 94733)
@@ -33,14 +33,37 @@
 
 
-/** Structure to store retranslated reminder values. */
+/** Update period types. */
+enum UpdatePeriodType
+{
+    UpdatePeriodType_Never  = -1,
+    UpdatePeriodType_1Day   =  0,
+    UpdatePeriodType_2Days  =  1,
+    UpdatePeriodType_3Days  =  2,
+    UpdatePeriodType_4Days  =  3,
+    UpdatePeriodType_5Days  =  4,
+    UpdatePeriodType_6Days  =  5,
+    UpdatePeriodType_1Week  =  6,
+    UpdatePeriodType_2Weeks =  7,
+    UpdatePeriodType_3Weeks =  8,
+    UpdatePeriodType_1Month =  9
+};
+
+
+/** Structure to store retranslated period type values. */
 struct VBoxUpdateDay
 {
     VBoxUpdateDay(const QString &strVal, const QString &strKey)
-        : val(strVal), key(strKey) {}
+        : val(strVal)
+        , key(strKey)
+    {}
 
-    bool operator==(const VBoxUpdateDay &other) const { return val == other.val || key == other.key; }
+    bool operator==(const VBoxUpdateDay &other) const
+    {
+        return    val == other.val
+               || key == other.key;
+    }
 
-    QString val;
-    QString key;
+    QString     val;
+    QString     key;
 };
 typedef QList<VBoxUpdateDay> VBoxUpdateDayList;
@@ -52,21 +75,4 @@
 public:
 
-    /** Period types. */
-    enum PeriodType
-    {
-        PeriodNever     = -2,
-        PeriodUndefined = -1,
-        Period1Day      =  0,
-        Period2Days     =  1,
-        Period3Days     =  2,
-        Period4Days     =  3,
-        Period5Days     =  4,
-        Period6Days     =  5,
-        Period1Week     =  6,
-        Period2Weeks    =  7,
-        Period3Weeks    =  8,
-        Period1Month    =  9
-    };
-
     /** Populates a set of update options. */
     static void populate();
@@ -76,6 +82,6 @@
     /** Constructs update description on the basis of passed @a strData. */
     VBoxUpdateData(const QString &strData = QString());
-    /** Constructs update description on the basis of passed @a enmPeriodIndex and @a enmUpdateChannel. */
-    VBoxUpdateData(PeriodType enmPeriodIndex, KUpdateChannel enmUpdateChannel);
+    /** Constructs update description on the basis of passed @a enmUpdatePeriod and @a enmUpdateChannel. */
+    VBoxUpdateData(UpdatePeriodType enmUpdatePeriod, KUpdateChannel enmUpdateChannel);
 
     /** Returns whether there is no need to check. */
@@ -83,8 +89,10 @@
     /** Returns whether there is really need to check. */
     bool isNeedToCheck() const;
+
     /** Returns update data. */
     QString data() const;
-    /** Returns period index. */
-    PeriodType periodIndex() const;
+
+    /** Returns update period. */
+    UpdatePeriodType updatePeriod() const;
     /** Returns update date. */
     QString date() const;
@@ -121,17 +129,17 @@
     void encode();
 
-    /** Holds the populated list of update options. */
-    static VBoxUpdateDayList m_dayList;
+    /** Holds the populated list of update period options. */
+    static VBoxUpdateDayList  s_days;
 
     /** Holds the update data. */
-    QString         m_strData;
-    /** Holds the update period index. */
-    PeriodType      m_enmPeriodIndex;
+    QString           m_strData;
+    /** Holds the update period. */
+    UpdatePeriodType  m_enmUpdatePeriod;
     /** Holds the update date. */
-    QDate           m_date;
+    QDate             m_date;
     /** Holds the update channel. */
-    KUpdateChannel  m_enmUpdateChannel;
+    KUpdateChannel    m_enmUpdateChannel;
     /** Holds the update version. */
-    UIVersion       m_version;
+    UIVersion         m_version;
 };
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/networking/UIUpdateManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/networking/UIUpdateManager.cpp	(revision 94732)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/networking/UIUpdateManager.cpp	(revision 94733)
@@ -364,5 +364,5 @@
     VBoxUpdateData currentData(gEDataManager->applicationUpdateData());
     /* Encode/save new update data: */
-    VBoxUpdateData newData(currentData.periodIndex(), currentData.updateChannel());
+    VBoxUpdateData newData(currentData.updatePeriod(), currentData.updateChannel());
     gEDataManager->setApplicationUpdateData(newData.data());
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIUpdateSettingsEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIUpdateSettingsEditor.cpp	(revision 94732)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIUpdateSettingsEditor.cpp	(revision 94733)
@@ -57,5 +57,5 @@
             {
                 if (m_pComboUpdatePeriod)
-                    m_pComboUpdatePeriod->setCurrentIndex(m_guiValue.periodIndex());
+                    m_pComboUpdatePeriod->setCurrentIndex(m_guiValue.updatePeriod());
                 if (m_mapRadioButtons.value(m_guiValue.updateChannel()))
                     m_mapRadioButtons.value(m_guiValue.updateChannel())->setChecked(true);
@@ -69,5 +69,5 @@
 VBoxUpdateData UIUpdateSettingsEditor::value() const
 {
-    return m_pCheckBox ? VBoxUpdateData(periodType(), updateChannel()) : m_guiValue;
+    return m_pCheckBox ? VBoxUpdateData(updatePeriod(), updateChannel()) : m_guiValue;
 }
 
@@ -141,5 +141,5 @@
 {
     if (m_pFieldUpdateDate)
-        m_pFieldUpdateDate->setText(VBoxUpdateData(periodType(), updateChannel()).date());
+        m_pFieldUpdateDate->setText(VBoxUpdateData(updatePeriod(), updateChannel()).date());
 }
 
@@ -265,10 +265,9 @@
 }
 
-VBoxUpdateData::PeriodType UIUpdateSettingsEditor::periodType() const
-{
-    const VBoxUpdateData::PeriodType enmResult = m_pCheckBox && m_pCheckBox->isChecked() && m_pComboUpdatePeriod
-                                               ? (VBoxUpdateData::PeriodType)m_pComboUpdatePeriod->currentIndex()
-                                               : VBoxUpdateData::PeriodNever;
-    return enmResult == VBoxUpdateData::PeriodUndefined ? VBoxUpdateData::Period1Day : enmResult;
+UpdatePeriodType UIUpdateSettingsEditor::updatePeriod() const
+{
+    return   m_pCheckBox && m_pCheckBox->isChecked() && m_pComboUpdatePeriod
+           ? (UpdatePeriodType)m_pComboUpdatePeriod->currentIndex()
+           : UpdatePeriodType_Never;
 }
 
@@ -276,4 +275,4 @@
 {
     QAbstractButton *pCheckedButton = m_pRadioButtonGroup ? m_pRadioButtonGroup->checkedButton() : 0;
-    return m_mapRadioButtons.key(pCheckedButton, KUpdateChannel_Stable);
-}
+    return m_mapRadioButtons.key(pCheckedButton, m_guiValue.updateChannel());
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIUpdateSettingsEditor.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIUpdateSettingsEditor.h	(revision 94732)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIUpdateSettingsEditor.h	(revision 94733)
@@ -72,6 +72,6 @@
     void prepareConnections();
 
-    /** Returns period type. */
-    VBoxUpdateData::PeriodType periodType() const;
+    /** Returns update period. */
+    UpdatePeriodType updatePeriod() const;
     /** Returns update channel. */
     KUpdateChannel updateChannel() const;